\begin{exercise}{6.3}
  I have used the full MNIST dataset to train a random forest with different values of \(J\) and \(M\). Figure~\ref{fig:6.3mnist} shows the result. It seems that the value of \(J\) is more important than the value of \(M\) since a single deep tree performs better than a lot of superficial trees.
  \begin{figure}
    \centering
    \begin{subfigure}{0.5\linewidth}
      \includegraphics[width=\linewidth]{\RootPathSheetSix/ex3/accuracies-mnist-train.pdf}
      \caption{MNIST train}
    \end{subfigure}\hfil
    \begin{subfigure}{0.5\linewidth}
      \includegraphics[width=\linewidth]{\RootPathSheetSix/ex3/accuracies-mnist-test.pdf}
      \caption{MNIST test}
    \end{subfigure}
    \caption{
      plot of the accuracies of Random Forest model for different values of \(J\) and \(M\), trained on MNIST dataset.
    }
    \label{fig:6.3mnist}
  \end{figure}

  The experiment has been repeated on a smaller and simpler dataset generated ad-hoc using parameters that can be seen in the code. The results nearly the same as before (Figure~\ref{fig:6.3adhoc}). \\
  The main difference is the presence of overfitting when \(J\) is larger than a certain threshold. The dataset has only 40 informative features and it's separable, so a single tree can discriminate completely a sample when \(2^{J+1}>40\). This is probably what is happening.
  
  \begin{figure}
    \centering
    \begin{subfigure}{0.5\linewidth}
      \includegraphics[width=\linewidth]{\RootPathSheetSix/ex3/accuracies-adhoc-train.pdf}
      \caption{ad-hoc train}
    \end{subfigure}\hfil
    \begin{subfigure}{0.5\linewidth}
      \includegraphics[width=\linewidth]{\RootPathSheetSix/ex3/accuracies-adhoc-test.pdf}
      \caption{ad-hoc test}
    \end{subfigure}
    \caption{
      plot of the accuracies of Random Forest model for different values of \(J\) and \(M\), trained on the ad-hoc dataset.
    }
    \label{fig:6.3adhoc}
  \end{figure}

  \pythoncode{\RootPathSheetSix/ex3/code.py}
\end{exercise}